#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

using namespace std;

/* Generates random tree. */
int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);

    /* Number of vertices. */
    int n = atoi(argv[1]);
    /* Parameter to specify tree form (t=0 stands for just random parent for a child). */
    int t = atoi(argv[2]);
    int pp = atoi(argv[3]);
    int q = atoi(argv[4]);

    /* Set parents. */
    vector<int> p(n);
    forn(i, n)
        if (i > 0)
            /* Parent is a number between 0..i-1, average value depends on t. */
            p[i] = rnd.wnext(i, t);

    printf("%d\n", n);
    vector<int> perm(n);
    forn(i, n)
        perm[i] = i;
    /* Random permutation of all vertices */
    shuffle(perm.begin(), perm.end());   

    for (int i = 0; i < n; i++)
   	{
   		int x = rnd.next(1, pp + q);
   		x = (int)(x > pp);
    	printf("%d", x);
    }
    printf("\n");

    vector<pair<int,int>> edges;
    for (int i = 1; i < n; i++)
        if (rnd.next(2))
            edges.push_back(make_pair(perm[i], perm[p[i]]));
        else
            edges.push_back(make_pair(perm[p[i]], perm[i]));

    shuffle(edges.begin(), edges.end());

    for (int i = 0; i + 1 < n; i++)
        printf("%d %d\n", edges[i].first + 1, edges[i].second + 1);
}