#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

int color[(int)2e5 + 10], color2[(int)2e5 + 10];

using namespace std;

/* Generates random tree. */
int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);

    /* Number of vertices. */
    int n = atoi(argv[1]);
    int k = atoi(argv[2]);

    printf("%d\n", n);
    vector<int> perm(n);
    forn(i, n)
        perm[i] = i;
    /* Random permutation of all vertices */
    shuffle(perm.begin(), perm.end());   
    color[0] = 0;
    for (int i = 1; i < n; i++)
    {
    	if (k)
    	{
    		color[i] = color[i / 2];
	    	if (i & 1)
	    		color[i] ^= 1;
    	}
    	else
    	{
    		color[i] = (i & 1);
    	}
    	color2[perm[i]] = color[i];
    }

    for (int i = 0; i < n; i++)
   	{
    	printf("%d", color2[i]);
    }
    printf("\n");

    vector<pair<int,int>> edges;
    for (int i = 1; i < n; i++)
        if (rnd.next(2))
            edges.push_back(make_pair(perm[i - 1], perm[i]));
        else
            edges.push_back(make_pair(perm[i], perm[i - 1]));

    shuffle(edges.begin(), edges.end());

    for (int i = 0; i + 1 < n; i++)
        printf("%d %d\n", edges[i].first + 1, edges[i].second + 1);
}