#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 3e5 + 7;

vector <int> g[N];
bool on[N];
int deg[N];

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector <pair <int, int> > e;
  set <pair <int, int> > tq;
  for (int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    a--, b--;
    if (a > b) swap(a, b);
    tq.insert({a, b});
    e.push_back({a, b});
    g[a].push_back(b);
    g[b].push_back(a);
  }
  for (int i = 0; i < n; i++) {
    sort(g[i].begin(), g[i].end());
  }
  ll ans = 0;
  for (int i = 0; i < n; i++) {
    for (int j : g[i]) {
      on[j] = true;
    }
    for (int j : g[i]) {
      for (int k : g[i]) {
        if (k >= j) {
          break;
        }
        if (tq.count({k, j})) {
          deg[j]++, deg[k]++;
        }
      }
    }
    for (int j : g[i]) {
      ans += deg[j] * (ll) (deg[j] - 1) / 2;
      on[j] = false;
      deg[j] = 0;
    }
  }
  cout << ans / 2 << '\n';
}
