#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  vector <ll> a(n);
  vector <ll> groups;
  function <void(ll)> solve = [&] (ll x) {
    ll pw = 1;
    for (ll &y : groups) {
      ll t = __gcd(y, x);
      if (1 < t) {
        ll go = x / t;
        y = t;
        solve(go);
        return;
      }
    }
    if (x != 1)
      groups.push_back(x);
  };
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    solve(a[i]);
  }
  vector <int> cnt(groups.size());
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < (int) groups.size(); j++) {
      if (a[i] % groups[j] == 0) {
        cnt[j]++;
      }
    }
  }
  cout << *max_element(cnt.begin(), cnt.end()) << '\n';
}
