#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <cstring>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

#pragma warning(disable : 4996)

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

using namespace std;

const int N = 105, M = 11, Z = 6000, A = 6, INF = 1e9;
vector<int> used(11), cov(11);
int a[M], b[M], to[Z * M][A], dp[N][Z],
	num[Z * M], nt[Z][1 << M], ch[M + 1], p[N], cb[1 << M],
	mk[N], suf[N], anc[N][Z][2], res_t[N];
string s[N];
int n, m, cv = 1;
bool vis[M + 1], en[Z];


int findSet(int v) {
	return p[v] == v ? v : p[v] = findSet(p[v]);
}

bool connect(int a, int b) {
	a = findSet(a);
	b = findSet(b);

	if (a == b)
		return false;
	p[b] = a;
	return true;
}

int f(int& a, int i) {
	return (a >> i) & 1;
}

int ct = 0;

void rec(int last = 0, int i = 0) {
	if (i == m) {
		int v = 0, mx = 0;
		for (int j = 0; j < m; j++) {
			if (to[v][a[j]] == -1) {
				to[v][a[j]] = cv++;
			}
			mx = max(mx, a[j]);
			v = to[v][a[j]];
		}
		if (mx == 1)
			en[ct] = 1;
		num[v] = ct++;
	}
	else {
		a[i] = 0;
		rec(0, i + 1);

		for (int j = 1; j <= 5; j++) {
			if (!cov[j] && (last == 0 || last == j)) {
				vector<int> tused = used,
					tcov = cov;

				a[i] = j;
				int x = 0;
				while (a[x] != j)
					x++;

				x++;
				while (x < i) {
					if (a[x] != j)
						cov[a[x]] = 1;
					x++;
				}

				bool off = !used[j];

				used[j] = 1;

				rec(j, i + 1);

				used = tused;
				cov = tcov;

				if (off)
					break;
			}
		}
	}
}

int findNum() {
	int v = 0;
	for (int i = 0; i < m; i++) {
		if (to[v][b[i]] == -1)
			exit(1);
		v = to[v][b[i]];
	}
	return num[v];
}

void dfs(int node = 0, int i = 0) {
	if (i == m) {
		int mx = 0;
		for (int j = 0; j < m; j++) {
			mx = max(mx, a[j]);
		}
		for (int h = 0; h < (1 << m); h++) {
			for (int j = 1; j <= 10; j++) {
				p[j] = j;
			}
			memset(vis, 0, sizeof(vis));
			for (int k = 0, col = 5; k < m; k++) {
				if (!f(h, k)) {
					b[k] = 0;
					continue;
				}
				if (k == 0 || f(h, k - 1) == 0) {
					col++;
				}
				b[k] = col;
				if (a[k] != 0) {
					vis[a[k]] = 1;
					if (!connect(a[k], col)) {
						nt[num[node]][h] = -1;
						break;
					}
				}
			}
			if (nt[num[node]][h] != -1) {
				memset(ch, -1, sizeof(ch));

				bool bad = false, emp = true;
				for (int k = 0; k < m; k++) {
					if (b[k]) {
						emp = false;
						b[k] = findSet(b[k]);
					}
				}

				for (int k = 1; k <= mx; k++) {
					if (!vis[k]) {
						bad = true;
						break;
					}
				}
				if (bad) {
					if (emp)
						nt[num[node]][h] = -2;
					else
						nt[num[node]][h] = -1;
				}
				else {
					for (int k = 0, col = 1; k < m; k++) {
						if (b[k]) {
							if (ch[b[k]] == -1) {
								ch[b[k]] = col++;
							}
							b[k] = ch[b[k]];
						}
					}
					nt[num[node]][h] = findNum();
				}
			}
		}
	}
	else {
		for (int j = 0; j < A; j++) {
			if (to[node][j] != -1) {
				a[i] = j;
				dfs(to[node][j], i + 1);
			}
		}
	}
}

signed main() {
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	memset(to, -1, sizeof(to));
	cin >> n >> m;

	

	rec();

	/*cout << "AAA";
	return 0;*/
	dfs();

	

	for (int i = 0; i < N; i++) {
		for (int j = 0; j < Z; j++) {
			dp[i][j] = INF;
		}
	}

	for (int i = 1; i < (1 << m); i++) {
		for (int j = 0; j < m; j++) {
			cb[i] += (i >> j) & 1;
		}
	}

	for (int i = 0; i < n; i++) {
		cin >> s[i];
		for (int j = 0; j < m; j++) {
			if (s[i][j] == '#')
				mk[i] |= 1 << j;
		}
		suf[i] = cb[mk[i]];
	}

	for (int i = n - 1; i >= 0; i--) {
		suf[i] += suf[i + 1];
	}

	dp[0][0] = 0;

	int ans = INF, x = -1, y = -1;

	for (int i = 0; i <= n; i++) {
		for (int j = 0; j < ct; j++) {
			if (dp[i][j] < INF) {
				for (int k = 0; k < (1 << m); k++) {
					if (nt[j][k] == -2) {

						if (en[j]) {
							if (ans > suf[i] + dp[i][j]) {
								ans = suf[i] + dp[i][j];
								x = i;
								y = j;
							}
						}
					}
					else if (i < n && nt[j][k] != -1) {
						int cur = dp[i][j] + cb[mk[i] ^ k];

						if (dp[i + 1][nt[j][k]] > cur) {
							dp[i + 1][nt[j][k]] = cur;
							anc[i + 1][nt[j][k]][0] = j;
							anc[i + 1][nt[j][k]][1] = k;
							/*if (k == 1023) {
								cout << i << " " << j << " " << cur << "\n";
							}*/
						}
					}
				}
			}
		}
	}

	/*b[0] = 1;
	b[1] = 0;
	b[2] = 2;
	cout << findNum() << "\n";*/

	/*cout << x << " " << y << "\n";*/

	/*cout << anc[x][y][1] << "\n";*/

	while (x > 0) {
		res_t[x - 1] = anc[x][y][1];
		y = anc[x][y][0];
		x--;
	}
	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if ((res_t[i] >> j) & 1) {
				cout << '#';
			}
			else {
				cout << '.';
			}
		}
		cout << "\n";
	}

	return 0;
}
