#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif

#include <string>
#include <set>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    println(n);
    vector<unsigned int> res(n);

    if (string(argv[2]) == "shuffle") {
        set<unsigned int> values;
        for (unsigned int i = 0; i < n / 3; i++) {
            values.insert(rnd.next(1, 1000000000));
        }
        unsigned int s = 0;
        for (unsigned int x : values) {
            res[s] = res[n - values.size() + s] = x;
            s++;
        }
        for (unsigned int i = values.size(); i < n - values.size(); i++) {
            res[i] = rnd.next(1, 1000000000);
        }
    } else if (string(argv[2]) == "random") {
        long long sl = 0;
        for (unsigned int i = 0; i < n / 3; i++) {
            sl += (res[i] = rnd.next(1, 1000000000));
        }
        if (sl == 0) {
            sl = rnd.next(1, 1000000000);
        }
        for (int i = n - 1; i >= n / 3; i--) {
            if (sl > 0) {
                sl -= (res[i] = rnd.next(1, static_cast<int>(min(1000000000LL, sl))));
            } else {
                res[i] = rnd.next(1, 1000000000);
            }
        }
    }

    for (unsigned int i = 0; i < static_cast<unsigned int>(n); i++) {
        if (i != 0) {
            printf(" ");
        }
        printf("%u", res[i]);
    }
    printf("\n");

}
