#include <iostream>
#include <vector>
#include <limits>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n;
    cin >> n;
    vector<unsigned long long> a(n + 1, 0);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i + 1];
        a[i + 1] += a[i];
    }

    unsigned int l = 1, r = n - 1, resl = 0, resr = 0;
    unsigned long long diff = numeric_limits<long long>::max();
    while (l <= r) {
        unsigned long long lsum = a[l], rsum = a[n] - a[r];
        if (rsum > lsum) {
            if (diff > rsum - lsum) {
                diff = rsum - lsum;
                resl = l;
                resr = r;
            }
            l++;
        } else if (rsum < lsum) {
            if (diff > lsum - rsum) {
                diff = lsum - rsum;
                resl = l;
                resr = r;
            }
            r--;
        } else {
            cout << 0 << ' ' << l << ' ' << r + 1 << '\n';
            return 0;
        }
    }

    cout << diff << ' ' << resl << ' ' << resr + 1 << '\n';

}
