#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	string type = argv[3];
	int l = atoi(argv[4]);

	vector<vector<char>> field(n, vector<char>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			field[i][j] = ".#"[rnd.next(0, 1)];
		}
	}

	int x1, y1, x2, y2;

	if (type == "hor") {
		x1 = rnd.next(0, n - 1);
		x2 = x1;
		y1 = rnd.next(0, m - l);
		y2 = y1 + l - 1;
	} else {
		y1 = rnd.next(0, m - 1);
		y2 = y1;
		x1 = rnd.next(0, n - l);
		x2 = x1 + l - 1;
	}

	for (int x = x1; x <= x2; ++x) {
		for (int y = y1; y <= y2; ++y) {
			field[x][y] = '.';
		}
	}

	for (int x = x1; x <= x2; ++x) {
		if (y1) {
			field[x][y1 - 1] = '#';
		}
		if (y2 < m - 1) {
			field[x][y2 + 1] = '#';
		}
	}

	for (int y = y1; y <= y2; ++y) {
		if (x1) {
			field[x1 - 1][y] = '#';
		}
		if (x2 < n - 1) {
			field[x2 + 1][y] = '#';
		}
	}

	if (type == "hor") {
		while (true) {
			int x = rnd.next(x1 - 1, x1 + 1);
			int y = rnd.next(y1, y2);
			if (x == x1 || x < 0 || x >= n) {
				continue;
			}
			field[x][y] = '.';
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && nx != x1) {
					field[nx][ny] = '#';
				}
			}
			break;
		}
	} else {
		while (true) {
			int x = rnd.next(x1, x2);
			int y = rnd.next(y1 - 1, y1 + 1);
			if (y == y1 || y < 0 || y >= m) {
				continue;
			}
			field[x][y] = '.';
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && ny != y1) {
					field[nx][ny] = '#';
				}
			}
			break;
		}
	}

	int sx, sy, fx, fy;
	while (true) {
		sx = rnd.next(x1, x2);
		sy = rnd.next(y1, y2);
		fx = rnd.next(x1, x2);
		fy = rnd.next(y1, y2);
		if (fx != sx || fy != sy) {
			break;
		}
	}

	field[sx][sy] = 's';
	field[fx][fy] = 'f';

	cout << n << " " << m << "\n";

	for (auto& v : field) {
		for (char c : v) {
			cout << c;
		}
		cout << "\n";
	}

	return 0;
}