#include <bits/stdc++.h>

using namespace std;

int n, m;
string s[1010];
int used[1010][1010];
int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

bool check(int x, int y)
{
	return x >= 0 && x < n && y >= 0 && y < m && s[x][y] != '#' && used[x][y] == 0;
}

void dfs(int x, int y)
{
	used[x][y] = 1;
	for (int i = 0; i < 4; i++)
	{
		int a = x + dx[i];
		int b = y + dy[i];
		if (check(a, b))
			dfs(a, b);
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	int a, b, c, d;
	a = b = c = d = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> s[i];
		for (int j = 0; j < m; j++)
		{
			if (s[i][j] == 's')
			{
				a = i;
				b = j;
			}
			else if (s[i][j] == 'f')
			{
				c = i;
				d = j;
			}
		}
	}
	dfs(a, b);
	if (used[c][d] == 0)
	{
		cout << -1 << endl;
		return 0;
	}
	int q = 0, w = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (used[i][j])
			{
				if (i != a)
					q = 1;
				if (j != b)
					w = 1;
			}
		}
	}
	if (q && w)
		cout << ((abs(a - c) + abs(b - d)) & 1) << endl;
	else
		cout << abs(a - c) + abs(b - d) << endl;
	return 0;
}