from collections import deque

n, m = map(int, input().split())
a = [input() for _ in range(n)]

s, f = (0, 0), (0, 0)
for i in range(n):
    for j in range(m):
        if a[i][j] == 's':
            s = (i, j)
        elif a[i][j] == 'f':
            f = (i, j)

mod2 = (s[0] + s[1] - f[0] - f[1]) % 2
vis = [[False for j in range(m)] for i in range(n)]


def ins(i, j):
    return 0 <= i < n and 0 <= j < m


queue = deque()
queue.append(s)
vis[s[0]][s[1]] = True

reach = False
move = s[0] != f[0] and s[1] != f[1]

while len(queue) > 0 and (not move or not reach):
    cur = queue.popleft()
    for x in ((-1, 0), (1, 0), (0, -1), (0, 1)):
        i1, j1 = cur[0] + x[0], cur[1] + x[1]
        if ins(i1, j1) and a[i1][j1] != '#' and not vis[i1][j1]:
            vis[i1][j1] = True
            if i1 == f[0] and j1 == f[1]:
                reach = True
            if s[0] == f[0] != i1 or s[1] == f[1] != j1:
                move = True
            queue.append((i1, j1))

if reach:
    if move:
        print(mod2)
    else:
        print(abs(s[0] - f[0]) + abs(s[1] - f[1]))
else:
    print(-1)
