#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 3e5 + 7;

vector <int> g[N];
bool on[N];
int deg[N];

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector <pair <int, int> > e;
  for (int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    a--, b--;
    e.push_back({a, b});
    g[a].push_back(b);
    g[b].push_back(a);
  }
  ll ans = 0;
  for (int i = 0; i < n; i++) {
    for (int j : g[i]) {
      on[j] = true;
    }
    for (auto c : e) {
      if (on[c.first] && on[c.second]) {
        deg[c.first]++, deg[c.second]++;
      }
    }
    for (int j : g[i]) {
      ans += deg[j] * (ll) (deg[j] - 1) / 2;
      on[j] = false;
      deg[j] = 0;
    }
  }
  cout << ans / 2 << '\n';
}
