#include <iostream>
#include <vector>
#include <limits>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n;
    cin >> n;
    vector<unsigned long long> a(n + 1, 0);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i + 1];
        a[i + 1] += a[i];
    }

    unsigned int resl = 0, resr = 0;
    unsigned long long diff = numeric_limits<long long>::max();
    for (unsigned int i = 1; i < n; i++) {
        for (unsigned int j = i; j < n; j++) {
            unsigned long long lsum = a[i], rsum = a[n] - a[j];
            unsigned long long res = lsum > rsum ? lsum - rsum : rsum - lsum;
            if (res < diff) {
                resl = i;
                resr = j;
                diff = res;
            }
        }
    }

    cout << diff << ' ' << resl << ' ' << resr + 1 << '\n';

}
