#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int cur_test = -1;
const int MAXN = 1e9;
const int MINN = 2;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int n, int m) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << n << ' ' << m << endl;
}

void gen_rand(int min_val, int max_val)
{
    write_test(rnd.next(min_val, max_val), rnd.next(min_val, max_val));
}

void gen_equal_rand(int min_val, int max_val)
{
    int x = rnd.next(min_val, max_val);
    write_test(x, x);
}

void gen_min()
{
    write_test(MINN, MINN);
}

void gen_max()
{
    write_test(MAXN, MAXN);
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    gen_min();
    for (int i = 10; i <= MAXN; i *= 10)
    {
        gen_rand(max(MINN, i / 10), i);
        gen_rand(max(MINN, i / 2), i);
        gen_equal_rand(max(MINN, i / 2), i);
    }
    gen_max();
    return 0;
}