#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	vector<vector<char>> field(n, vector<char>(m, '#'));

	int x = 0, y = 0;
	int dir = 0;
	int cnt = 0;

	while (true) {
		field[x][y] = '.';
		int nx = x + dx[dir];
		int ny = y + dy[dir];
		if (nx < 0 || nx >= n || ny < 0 || ny >= m) {
			if (cnt <= 1) {
				break;
			}
			cnt = 0;
			dir = (dir + 1) % 4;
			continue;
		}
		int nnx = nx + dx[dir];
		int nny = ny + dy[dir];
		if (0 <= nnx && nnx < n && 0 <= nny && nny < m && field[nnx][nny] == '.') {
			if (cnt <= 1) {
				break;
			}
			cnt = 0;
			dir = (dir + 1) % 4;
			continue;
		}
		x = nx; y = ny;
		++cnt;
	}

	field[x][y] = 'f';
	field[0][0] = 's';

	cout << n << " " << m << "\n";
	for (auto& s : field) {
		for (char c : s) {
			cout << c;
		}
		cout << "\n";
	}

	return 0;
}