#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);

	vector<int> b(n);
	iota(b.begin(), b.end(), 0);
	shuffle(b.begin(), b.end());

	function<vector<int>(vector<int>)> build = [&](vector<int> arr) {
		if (szof(arr) == 1) {
			return arr;
		}
		vector<int> left(arr.begin(), arr.begin() + szof(arr) / 2), right(arr.begin() + szof(arr) / 2, arr.end());
		auto res_left = build(left);
		auto res_right = build(right);
		vector<int> order;
		for (int i = 0; i < szof(left); ++i) {
			order.push_back(0);
		}
		for (int i = 0; i < szof(right); ++i) {
			order.push_back(1);
		}

		shuffle(order.begin(), order.end());
		int cnt_left = 0, cnt_right = 0;
		vector<int> ret;
		for (int t : order) {
			if (t == 0) {
				ret.push_back(left[cnt_left++]);
			} else {
				ret.push_back(right[cnt_right++]);
			}
		}
		return ret;
	};
	auto a = build(b);

	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		cout << a[i] + 1;
		if (i < n - 1) {
			cout << " ";
		}
	}
	cout << "\n";

	for (int i = 0; i < n; ++i) {
		cout << b[i] + 1;
		if (i < n - 1) {
			cout << " ";
		}
	}
	cout << "\n";
	return 0;
}