#include "testlib.h"
#include <vector>

using namespace std;

const int MAXN = 10'000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();

    vector<bool> used(n);
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            inf.readSpace();
        }
        int a = inf.readInt(1, n, format("a[%d]", i)) - 1;
        ensuref(!used[a], "duplicate index %d", a);
        used[a] = true;
    }
    inf.readEoln();

    used.assign(n, false);
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            inf.readSpace();
        }
        int a = inf.readInt(1, n, format("b[%d]", i)) - 1;
        ensuref(!used[a], "duplicate index %d", a);
        used[a] = true;
    }
    inf.readEoln();

    inf.readEof();
}