#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> ans;

void solve(vector<int>& p, int index) {
    if (p.size() == 1) {
        return;
    }
    while (index >= ans.size()) {
        ans.emplace_back();
    }
    int M = p.size() / 2;
    vector<int> lhs, rhs;
    for (int i = 0; i < M; ++i) {
        ans[index].push_back(p[i]);
        lhs.push_back(p[i]);
    }
    reverse(lhs.begin(), lhs.end());
    for (int i = M; i < p.size(); ++i) {
        rhs.push_back(p[i]);
    }
    solve(lhs, index + 1);
    solve(rhs, index + 1);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
    }

    vector<int> ar(n);
    for (int i = 0; i < n; ++i) {
        ar[a[i]] = i;
    }
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = ar[b[i]];
    }

    solve(p, 0);
    reverse(ans.begin(), ans.end());

    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); ++i) {
        if (!ans[i].empty()) {
            cout << ans[i].size();
            for (int j : ans[i]) {
                cout << " " << a[j] + 1;
            }
            cout << "\n";
        }
    }

    return 0;
}
